package arm.node;

@:access(armory.logicnode.LogicNode)@:keep class Player extends armory.logicnode.LogicTree {

	var functionNodes:Map<String, armory.logicnode.FunctionNode>;

	var functionOutputNodes:Map<String, armory.logicnode.FunctionOutputNode>;

	public function new() {
		super();
		this.functionNodes = new Map();
		this.functionOutputNodes = new Map();
		notifyOnAdd(add);
	}

	override public function add() {
		var _ApplyForce = new armory.logicnode.ApplyForceNode(this);
		_ApplyForce.preallocInputs(4);
		_ApplyForce.preallocOutputs(1);
		var _Keyboard = new armory.logicnode.MergedKeyboardNode(this);
		_Keyboard.property0 = "down";
		_Keyboard.property1 = "a";
		_Keyboard.preallocInputs(0);
		_Keyboard.preallocOutputs(2);
		armory.logicnode.LogicNode.addLink(_Keyboard, new armory.logicnode.BooleanNode(this, false), 1, 0);
		armory.logicnode.LogicNode.addLink(_Keyboard, _ApplyForce, 0, 0);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.ObjectNode(this, ""), _ApplyForce, 0, 1);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.VectorNode(this, 0.0,-20.0,0.0), _ApplyForce, 0, 2);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.BooleanNode(this, false), _ApplyForce, 0, 3);
		armory.logicnode.LogicNode.addLink(_ApplyForce, new armory.logicnode.NullNode(this), 0, 0);
		var _ApplyForce_001 = new armory.logicnode.ApplyForceNode(this);
		_ApplyForce_001.preallocInputs(4);
		_ApplyForce_001.preallocOutputs(1);
		var _Keyboard_001 = new armory.logicnode.MergedKeyboardNode(this);
		_Keyboard_001.property0 = "down";
		_Keyboard_001.property1 = "d";
		_Keyboard_001.preallocInputs(0);
		_Keyboard_001.preallocOutputs(2);
		armory.logicnode.LogicNode.addLink(_Keyboard_001, new armory.logicnode.BooleanNode(this, false), 1, 0);
		armory.logicnode.LogicNode.addLink(_Keyboard_001, _ApplyForce_001, 0, 0);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.ObjectNode(this, ""), _ApplyForce_001, 0, 1);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.VectorNode(this, 0.0,20.0,0.0), _ApplyForce_001, 0, 2);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.BooleanNode(this, false), _ApplyForce_001, 0, 3);
		armory.logicnode.LogicNode.addLink(_ApplyForce_001, new armory.logicnode.NullNode(this), 0, 0);
		var _ApplyForce_002 = new armory.logicnode.ApplyForceNode(this);
		_ApplyForce_002.preallocInputs(4);
		_ApplyForce_002.preallocOutputs(1);
		var _Keyboard_002 = new armory.logicnode.MergedKeyboardNode(this);
		_Keyboard_002.property0 = "down";
		_Keyboard_002.property1 = "w";
		_Keyboard_002.preallocInputs(0);
		_Keyboard_002.preallocOutputs(2);
		armory.logicnode.LogicNode.addLink(_Keyboard_002, new armory.logicnode.BooleanNode(this, false), 1, 0);
		armory.logicnode.LogicNode.addLink(_Keyboard_002, _ApplyForce_002, 0, 0);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.ObjectNode(this, ""), _ApplyForce_002, 0, 1);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.VectorNode(this, -20.0,0.0,0.0), _ApplyForce_002, 0, 2);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.BooleanNode(this, false), _ApplyForce_002, 0, 3);
		armory.logicnode.LogicNode.addLink(_ApplyForce_002, new armory.logicnode.NullNode(this), 0, 0);
		var _ApplyForce_003 = new armory.logicnode.ApplyForceNode(this);
		_ApplyForce_003.preallocInputs(4);
		_ApplyForce_003.preallocOutputs(1);
		var _Keyboard_003 = new armory.logicnode.MergedKeyboardNode(this);
		_Keyboard_003.property0 = "down";
		_Keyboard_003.property1 = "s";
		_Keyboard_003.preallocInputs(0);
		_Keyboard_003.preallocOutputs(2);
		armory.logicnode.LogicNode.addLink(_Keyboard_003, new armory.logicnode.BooleanNode(this, false), 1, 0);
		armory.logicnode.LogicNode.addLink(_Keyboard_003, _ApplyForce_003, 0, 0);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.ObjectNode(this, ""), _ApplyForce_003, 0, 1);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.VectorNode(this, 20.0,0.0,0.0), _ApplyForce_003, 0, 2);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.BooleanNode(this, false), _ApplyForce_003, 0, 3);
		armory.logicnode.LogicNode.addLink(_ApplyForce_003, new armory.logicnode.NullNode(this), 0, 0);
		var _TranslateOnLocalAxis = new armory.logicnode.TranslateOnLocalAxisNode(this);
		_TranslateOnLocalAxis.preallocInputs(5);
		_TranslateOnLocalAxis.preallocOutputs(1);
		var _OnUpdate = new armory.logicnode.OnUpdateNode(this);
		_OnUpdate.property0 = "Update";
		_OnUpdate.preallocInputs(0);
		_OnUpdate.preallocOutputs(1);
		armory.logicnode.LogicNode.addLink(_OnUpdate, _TranslateOnLocalAxis, 0, 0);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.ObjectNode(this, ""), _TranslateOnLocalAxis, 0, 1);
		var _Float = new armory.logicnode.FloatNode(this);
		_Float.preallocInputs(1);
		_Float.preallocOutputs(1);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.FloatNode(this, 0.0), _Float, 0, 0);
		armory.logicnode.LogicNode.addLink(_Float, _TranslateOnLocalAxis, 0, 2);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.IntegerNode(this, 1), _TranslateOnLocalAxis, 0, 3);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.BooleanNode(this, false), _TranslateOnLocalAxis, 0, 4);
		armory.logicnode.LogicNode.addLink(_TranslateOnLocalAxis, new armory.logicnode.NullNode(this), 0, 0);
		var _SetSceneActive = new armory.logicnode.SetSceneNode(this);
		_SetSceneActive.preallocInputs(2);
		_SetSceneActive.preallocOutputs(2);
		var _OnContactArray = new armory.logicnode.OnContactArrayNode(this);
		_OnContactArray.property0 = "begin";
		_OnContactArray.preallocInputs(2);
		_OnContactArray.preallocOutputs(1);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.ObjectNode(this, ""), _OnContactArray, 0, 0);
		var _Collection = new armory.logicnode.GroupNode(this);
		_Collection.property0 = "Collection 2";
		_Collection.preallocInputs(0);
		_Collection.preallocOutputs(1);
		armory.logicnode.LogicNode.addLink(_Collection, _OnContactArray, 0, 1);
		armory.logicnode.LogicNode.addLink(_OnContactArray, _SetSceneActive, 0, 0);
		var _GetSceneActive_001 = new armory.logicnode.ActiveSceneNode(this);
		_GetSceneActive_001.preallocInputs(0);
		_GetSceneActive_001.preallocOutputs(1);
		armory.logicnode.LogicNode.addLink(_GetSceneActive_001, _SetSceneActive, 0, 1);
		armory.logicnode.LogicNode.addLink(_SetSceneActive, new armory.logicnode.NullNode(this), 0, 0);
		armory.logicnode.LogicNode.addLink(_SetSceneActive, new armory.logicnode.ObjectNode(this, ""), 1, 0);
		var _SetSceneActive_001 = new armory.logicnode.SetSceneNode(this);
		_SetSceneActive_001.preallocInputs(2);
		_SetSceneActive_001.preallocOutputs(2);
		var _Gate = new armory.logicnode.GateNode(this);
		_Gate.property0 = "Less Equal";
		_Gate.property1 = 9.999999747378752e-05;
		_Gate.preallocInputs(3);
		_Gate.preallocOutputs(2);
		var _OnTimer = new armory.logicnode.OnTimerNode(this);
		_OnTimer.preallocInputs(2);
		_OnTimer.preallocOutputs(1);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.FloatNode(this, 0.0), _OnTimer, 0, 0);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.BooleanNode(this, true), _OnTimer, 0, 1);
		armory.logicnode.LogicNode.addLink(_OnTimer, _Gate, 0, 0);
		var _GetObjectLocation = new armory.logicnode.GetLocationNode(this);
		_GetObjectLocation.preallocInputs(2);
		_GetObjectLocation.preallocOutputs(1);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.ObjectNode(this, ""), _GetObjectLocation, 0, 0);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.BooleanNode(this, false), _GetObjectLocation, 0, 1);
		armory.logicnode.LogicNode.addLink(_GetObjectLocation, _Gate, 0, 1);
		var _Vector = new armory.logicnode.VectorNode(this);
		_Vector.preallocInputs(3);
		_Vector.preallocOutputs(1);
		var _SeparateXYZ = new armory.logicnode.SeparateVectorNode(this);
		_SeparateXYZ.preallocInputs(1);
		_SeparateXYZ.preallocOutputs(3);
		armory.logicnode.LogicNode.addLink(_GetObjectLocation, _SeparateXYZ, 0, 0);
		armory.logicnode.LogicNode.addLink(_SeparateXYZ, new armory.logicnode.FloatNode(this, 0.0), 2, 0);
		armory.logicnode.LogicNode.addLink(_SeparateXYZ, _Vector, 0, 0);
		armory.logicnode.LogicNode.addLink(_SeparateXYZ, _Vector, 1, 1);
		armory.logicnode.LogicNode.addLink(new armory.logicnode.FloatNode(this, 5.0), _Vector, 0, 2);
		armory.logicnode.LogicNode.addLink(_Vector, _Gate, 0, 2);
		armory.logicnode.LogicNode.addLink(_Gate, new armory.logicnode.NullNode(this), 0, 0);
		armory.logicnode.LogicNode.addLink(_Gate, _SetSceneActive_001, 1, 0);
		var _GetSceneActive = new armory.logicnode.ActiveSceneNode(this);
		_GetSceneActive.preallocInputs(0);
		_GetSceneActive.preallocOutputs(1);
		armory.logicnode.LogicNode.addLink(_GetSceneActive, _SetSceneActive_001, 0, 1);
		armory.logicnode.LogicNode.addLink(_SetSceneActive_001, new armory.logicnode.NullNode(this), 0, 0);
		armory.logicnode.LogicNode.addLink(_SetSceneActive_001, new armory.logicnode.ObjectNode(this, ""), 1, 0);
	}
}